// -*- C++ -*-
//
// ChAssert - a "smart" assert()
//
// Define libCh_NODEBUG to turn all ASSERT() calls into no-ops.
//
// Copyright © 1997-1998 Arcane Dragon Software
//                       Chris Herborth (chrish@kagi.com)
//
// $Id: ChAssert.h,v 1.4 1998/04/10 14:28:39 chrish Exp $

#ifndef libCh_ASSERT_H
#define libCh_ASSERT_H

#pragma once

extern "C" {
void libCh_GUI_assert( const char *as_cond,
					   const char *as_msg,
					   const char *as_file,
					   const char *as_date,
					   const char *as_time,
					   const int as_line );
}

#if !defined(libCh_NODEBUG) && !defined(NDEBUG) && !defined(NODEBUG)
#  define ASSERT(cond,msg) ((cond) ? ((void) 0) : \
							libCh_GUI_assert( #cond, msg, __FILE__, \
							__DATE__, __TIME__, \
							__LINE__ ) )
#else
#  define ASSERT(cond,msg) ((void)0)
#endif

#endif
