// -*- C++ -*-
//
// ChSigApplication - a BApplication that knows about POSIX signals and
//                    can deal with them properly.
//
// Copyright © 1998 Arcane Dragon Software
//                  Chris Herborth (chrish@kagi.com)
//
// $Id: ChSigApplication.h,v 1.4 1998/04/14 11:39:23 chrish Exp $

#ifndef libCh_SIGAPPLICATION_H
#define libCh_SIGAPPLICATION_H

#pragma once

#include "Ch/ChDefs.h"	// For messages.

#include <app/Application.h>
#include <kernel/OS.h>
#include <signal.h>

class ChSigApplication : public BApplication
{
public:
	ChSigApplication( const char *app_signature, sigset_t *set = NULL,
					  int max_sig = NSIG );
	virtual ~ChSigApplication( void );

	// Override things from BApplication
	virtual void MessageReceived( BMessage *msg );

	// Handle POSIX signals
	virtual void SignalReceived( int signo );

	// Quit now
	virtual void QuitDemanded( void );

	// Did we init properly?
	virtual bool IsValid( void ) { return _valid; }

#if __MWERKS__ >= 0x2010
	typedef BApplication inherited;
#endif

	sem_id proxy_sem;

private:
	ChSigApplication( const ChSigApplication& );		// Don't copy me
	ChSigApplication& operator=( ChSigApplication& );	// Don't assign me

	thread_id _proxy_tid;
	bool _valid;

	static char *_rcs_id;
};

#endif
